Based on patch from Marty Leisner <leisner@sdsp.mc.xerox.com>:
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash db tcl tk tclX itcl"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 # Note, the powerpc-eabi build depends on sim occurring before gdb in order to
52 # know that we are building the simulator.
53 host_tools="texinfo byacc flex bison binutils ld gas gcc sim gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk findutils sn"
54
55
56 # these libraries are built for the target environment, and are built after
57 # the host libraries and the host tools (which may be a cross compiler)
58 #
59 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
60
61
62 # these tools are built using the target libs, and are intended to run only
63 # in the target environment
64 #
65 # note: any program that *uses* libraries that are in the "target_libs"
66 # list belongs in this list. those programs are also very likely
67 # candidates for the "native_only" list which follows
68 #
69 target_tools="target-examples target-groff"
70
71 ################################################################################
72
73 ## These two lists are of directories that are to be removed from the
74 ## ${configdirs} list for either cross-compilations or for native-
75 ## compilations. For example, it doesn't make that much sense to
76 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
77 ## a native environment.
78
79 # directories to be built in the native environment only
80 #
81 # This must be a single line because of the way it is searched by grep in
82 # the code below.
83 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms sn"
84
85 # directories to be built in a cross environment only
86 #
87 cross_only="target-libiberty target-libgloss target-newlib"
88
89 ## All tools belong in one of the four categories, and are assigned above
90 ## We assign ${configdirs} this way to remove all embedded newlines. This
91 ## is important because configure will choke if they ever get through.
92 ## ${configdirs} is directories we build using the host tools.
93 ## ${target_configdirs} is directories we build using the target tools.
94 #
95 configdirs=`echo ${host_libs} ${host_tools}`
96 target_configdirs=`echo ${target_libs} ${target_tools}`
97
98 ################################################################################
99
100 srctrigger=move-if-change
101 srcname="gnu development package"
102
103 # This gets set non-empty for some net releases of packages.
104 appdirs=""
105
106 # per-host:
107
108 # Work in distributions that contain no compiler tools, like Autoconf.
109 if [ -d ${srcdir}/config ]; then
110 case "${host}" in
111 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
112 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
113 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
114 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
115 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
116 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
117 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
118 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
119 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
120 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
121 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
122 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
123 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
124 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
125 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
126 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
127 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
128 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
129 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
130 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
131 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
132 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
133 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
134 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
135 *-windows*) host_makefile_frag=config/mh-windows ;;
136 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
137 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
138 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
139 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
140 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
141 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
142 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
143 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
144 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
145 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
146 esac
147 fi
148
149 # If we aren't going to be using gcc, see if we can extract a definition
150 # of CC from the fragment.
151 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
152 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
153 found=
154 for dir in $PATH; do
155 test -z "$dir" && dir=.
156 if test -f $dir/gcc; then
157 found=yes
158 break
159 fi
160 done
161 IFS="$save_ifs"
162 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
163 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
164 if [ -n "${xx}" ] ; then
165 CC=$xx
166 fi
167 fi
168 fi
169
170 # We default to --with-shared on platforms where -fpic is meaningless.
171 # Well, we don't yet, but we will.
172 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
173 case "${target}" in
174 alpha-dec-osf*) enable_shared=yes ;;
175 alpha-*-linux*) enable_shared=yes ;;
176 mips-sgi-irix5*) enable_shared=yes ;;
177 *) enable_shared=no ;;
178 esac
179 fi
180
181 case "${enable_shared}" in
182 yes) shared=yes ;;
183 no) shared=no ;;
184 "") shared=no ;;
185 *) shared=yes ;;
186 esac
187
188 if [ x${shared} = xyes ]; then
189 waugh=
190 case "${host}" in
191 hppa*) waugh=config/mh-papic ;;
192 i[3456]86-*) waugh=config/mh-x86pic ;;
193 sparc64-*) waugh=config/mh-sparcpic ;;
194 *) waugh=config/mh-${host_cpu}pic ;;
195 esac
196 if [ -f ${srcdir}/${waugh} ]; then
197 if [ -n "${host_makefile_frag}" ] ; then
198 cat ${srcdir}/${host_makefile_frag} > mh-frag
199 cat ${srcdir}/${waugh} >> mh-frag
200 host_makefile_frag=mh-frag
201 else
202 host_makefile_frag=${waugh}
203 fi
204 fi
205 fi
206
207 # per-target:
208
209 case "${target}" in
210 v810*) target_makefile_frag=config/mt-v810 ;;
211 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
212 # start-sanitize-r5900
213 mips64vr5900*-*-*) target_makefile_frag=config/mt-r5900 ;;
214 # end-sanitize-r5900
215 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
216 esac
217
218 skipdirs=
219 gasdir=gas
220 use_gnu_ld=
221 use_gnu_as=
222
223 # some tools are so dependent upon X11 that if we're not building with X,
224 # it's not even worth trying to configure, much less build, that tool.
225
226 case ${with_x} in
227 yes | "") # the default value for this tree is that X11 is available
228 ;;
229 no)
230 skipdirs="${skipdirs} tk gash"
231 ;;
232 *)
233 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
234 ;;
235 esac
236
237 # Some tools are only suitable for building in a "native" situation.
238 # Those are added when we have a host==target configuration. For cross
239 # toolchains, we add some directories that should only be useful in a
240 # cross-compiler.
241
242 is_cross_compiler=
243
244 if [ x"${host}" = x"${target}" ] ; then
245 # when doing a native toolchain, don't build the targets
246 # that are in the 'cross only' list
247 skipdirs="${skipdirs} ${cross_only}"
248 is_cross_compiler=no
249 target_subdir=.
250 else
251 # similarly, don't build the targets in the 'native only'
252 # list when building a cross compiler
253 skipdirs="${skipdirs} ${native_only}"
254 is_cross_compiler=yes
255 target_subdir=${target_alias}
256 if [ ! -d ${target_subdir} ] ; then
257 if mkdir ${target_subdir} ; then true
258 else
259 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
260 exit 1
261 fi
262 fi
263 fi
264
265 copy_dirs=
266
267 # Handle --with-headers=XXX. The contents of the named directory are
268 # copied to $(tooldir)/sys-include.
269 if [ x"${with_headers}" != x ]; then
270 if [ x${is_cross_compiler} = xno ]; then
271 echo 1>&2 '***' --with-headers is only supported when cross compiling
272 exit 1
273 fi
274 case "${exec_prefixoption}" in
275 "") x=${prefix} ;;
276 *) x=${exec_prefix} ;;
277 esac
278 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
279 fi
280
281 # Handle --with-libs=XXX. Multiple directories are permitted. The
282 # contents are copied to $(tooldir)/lib.
283 if [ x"${with_libs}" != x ]; then
284 if [ x${is_cross_compiler} = xno ]; then
285 echo 1>&2 '***' --with-libs is only supported when cross compiling
286 exit 1
287 fi
288 # Copy the libraries in reverse order, so that files in the first named
289 # library override files in subsequent libraries.
290 case "${exec_prefixoption}" in
291 "") x=${prefix} ;;
292 *) x=${exec_prefix} ;;
293 esac
294 for l in ${with_libs}; do
295 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
296 done
297 fi
298
299 # If both --with-headers and --with-libs are specified, default to
300 # --without-newlib.
301 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
302 if [ x"${with_newlib}" = x ]; then
303 with_newlib=no
304 fi
305 fi
306
307 # Recognize --with-newlib/--without-newlib.
308 if [ x${with_newlib} = xno ]; then
309 skipdirs="${skipdirs} target-newlib"
310 elif [ x${with_newlib} = xyes ]; then
311 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
312 fi
313
314 # Default to using --with-stabs for certain targets.
315 if [ x${with_stabs} = x ]; then
316 case "${target}" in
317 mips*-*-irix6*)
318 ;;
319 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
320 with_stabs=yes;
321 withoptions="${withoptions} --with-stabs"
322 ;;
323 esac
324 fi
325
326 # Handle ${copy_dirs}
327 set fnord ${copy_dirs}
328 shift
329 while [ $# != 0 ]; do
330 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
331 :
332 else
333 echo Copying $1 to $2
334
335 # Use the install script to create the directory and all required
336 # parent directories.
337 if [ -d $2 ]; then
338 :
339 else
340 echo >config.temp
341 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
342 fi
343
344 # Copy the directory, assuming we have tar.
345 # FIXME: Should we use B in the second tar? Not all systems support it.
346 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
347
348 # It is the responsibility of the user to correctly adjust all
349 # symlinks. If somebody can figure out how to handle them correctly
350 # here, feel free to add the code.
351
352 echo $1 > $2/COPIED
353 fi
354 shift; shift
355 done
356
357 # Configure extra directories which are host specific
358
359 case "${host}" in
360 i[3456]86-*-go32*)
361 configdirs="$configdirs dosrel" ;;
362 *-cygwin32*)
363 configdirs="$configdirs dosrel" ;;
364 esac
365
366 # Remove more programs from consideration, based on the host or
367 # target this usually means that a port of the program doesn't
368 # exist yet.
369
370 noconfigdirs=""
371
372 case "${host}" in
373 i[3456]86-*-vsta)
374 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl db sn"
375 ;;
376 i[3456]86-*-go32)
377 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet itcl db sn"
378 ;;
379 *-*-cygwin32)
380 noconfigdirs="expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet itcl db sn"
381 ;;
382 *-*-windows*)
383 # This is only used to build WinGDB...
384 configdirs="bfd gdb libiberty opcodes readline sim"
385 target_configdirs=
386 ;;
387 ppc*-*-pe)
388 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet itcl db sn"
389 ;;
390 esac
391
392
393 case "${target}" in
394 *-*-netware)
395 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
396 ;;
397 *-*-vxworks*)
398 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
399 ;;
400 alpha-dec-osf*)
401 # ld works, but does not support shared libraries. emacs doesn't
402 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
403 # gas doesn't generate exception information.
404 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
405 ;;
406 alpha*-*-*vms*)
407 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
408 ;;
409 alpha*-*-*)
410 # newlib is not 64 bit ready
411 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
412 ;;
413 # start-sanitize-arc
414 arc-*-*)
415 noconfigdirs="$noconfigdirs target-libgloss"
416 ;;
417 # end-sanitize-arc
418 arm-*-pe*)
419 noconfigdirs="$noconfigdirs target-libgloss"
420 ;;
421 arm-*-coff*)
422 noconfigdirs="$noconfigdirs target-libgloss"
423 ;;
424 arm-*-riscix*)
425 noconfigdirs="$noconfigdirs ld target-libgloss"
426 ;;
427 d10v-*-*)
428 noconfigdirs="$noconfigdirs target-librx target-libg++ target-libstdc++ target-libio target-libgloss"
429 ;;
430 # start-sanitize-d30v
431 d30v-*-*)
432 noconfigdirs="$noconfigdirs tcl tk expect gcc gdb newlib target-librx target-libg++ target-libstdc++ target-libio target-libgloss itcl db sn target-libiberty target-newlib target-examples"
433 ;;
434 # end-sanitize-d30v
435 h8300*-*-* | \
436 h8500-*-*)
437 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
438 ;;
439 hppa*-*-*elf* | \
440 hppa*-*-lites*)
441 # Do configure ld/binutils/gas for this case.
442 ;;
443 hppa*-*-*)
444 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
445 # cc is gcc, and on any system a user should be able to link cc to
446 # whatever they want. FIXME, emacs emacs19).
447 case "${CC}" in
448 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
449 *) ;;
450 esac
451 noconfigdirs="$noconfigdirs ld shellutils"
452 ;;
453 i[3456]86-*-go32)
454 # but don't build gdb
455 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
456 ;;
457 *-*-cygwin32)
458 target_configdirs="$target_configdirs target-winsup"
459 noconfigdirs="$noconfigdirs expect target-libgloss itcl db sn"
460 # always build newlib.
461 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
462
463 # Can't build gdb for cygwin32 if not native.
464 case "${host}" in
465 *-*-cygwin32) ;; # keep gdb
466 *) noconfigdirs="$noconfigdirs gdb"
467 esac
468 ;;
469 i[3456]86-*-pe)
470 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
471 ;;
472 i[3456]86-*-sco3.2v5*)
473 # The linker does not yet know about weak symbols in COFF,
474 # and is not configured to handle mixed ELF and COFF.
475 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
476 ;;
477 i[3456]86-*-sco*)
478 noconfigdirs="$noconfigdirs gprof target-libgloss"
479 ;;
480 i[3456]86-*-solaris2*)
481 # The linker does static linking correctly, but the Solaris C library
482 # has bugs such that some important functions won't work when statically
483 # linked. (See man pages for getpwuid, for example.)
484 noconfigdirs="$noconfigdirs ld target-libgloss"
485 ;;
486 i[3456]86-*-sysv4*)
487 # The SYSV4 C compiler doesn't handle Emacs correctly
488 case "${CC}" in
489 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
490 *) ;;
491 esac
492 # but that's okay since emacs doesn't work anyway
493 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
494 ;;
495 mn10200-*-*)
496 noconfigdirs="$noconfigdirs target-libgloss"
497 ;;
498 mn10300-*-*)
499 noconfigdirs="$noconfigdirs target-libgloss"
500 ;;
501 powerpc-*-aix*)
502 # copied from rs6000-*-* entry
503 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
504 # This is needed until gcc and ld are fixed to work together.
505 use_gnu_ld=no
506 ;;
507 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
508 target_configdirs="$target_configdirs target-winsup"
509 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss itcl db sn"
510 # always build newlib.
511 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
512 ;;
513 # This is temporary until we can link against shared libraries
514 powerpcle-*-solaris*)
515 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect itcl db sn"
516 ;;
517 rs6000-*-lynxos*)
518 # The CVS server code doesn't work on the RS/6000
519 # Newlib makes problems for libg++ in crosses.
520 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
521 ;;
522 rs6000-*-aix*)
523 noconfigdirs="$noconfigdirs gprof"
524 # This is needed until gcc and ld are fixed to work together.
525 use_gnu_ld=no
526 ;;
527 rs6000-*-*)
528 noconfigdirs="$noconfigdirs gprof"
529 ;;
530 m68k-apollo-*)
531 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
532 ;;
533 mips*-*-irix5*)
534 # The GNU linker does not support shared libraries.
535 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
536 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
537 ;;
538 mips*-*-irix6*)
539 # The GNU linker does not support shared libraries.
540 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
541 noconfigdirs="$noconfigdirs ld gas gprof emacs target-libgloss"
542 ;;
543 mips*-dec-bsd*)
544 noconfigdirs="$noconfigdirs gprof target-libgloss"
545 ;;
546 mips*-*-bsd*)
547 noconfigdirs="$noconfigdirs gprof target-libgloss"
548 ;;
549 mips*-*-*)
550 noconfigdirs="$noconfigdirs gprof"
551 ;;
552 romp-*-*)
553 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
554 ;;
555 sh-*-*)
556 case "${host}" in
557 i[3456]86-*-vsta) ;; # don't add gprof back in
558 i[3456]86-*-go32) ;; # don't add gprof back in
559 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
560 esac
561 noconfigdirs="$noconfigdirs target-libgloss"
562 ;;
563 sparc-*-sunos4*)
564 if [ x${is_cross_compiler} != xno ] ; then
565 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
566 else
567 use_gnu_ld=no
568 fi
569 ;;
570 # start-sanitize-tic80
571 tic80-*-*)
572 noconfigdirs="$noconfigdirs gdb"
573 ;;
574 # end-sanitize-tic80
575 v810-*-*)
576 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
577 ;;
578 # start-sanitize-v850
579 v850-*-*)
580 noconfigdirs="$noconfigdirs target-libgloss"
581 ;;
582 # end-sanitize-v850
583 vax-*-vms)
584 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
585 ;;
586 vax-*-*)
587 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
588 ;;
589 *-*-lynxos*)
590 # Newlib makes problems for libg++ in crosses.
591 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
592 ;;
593 *-*-macos* | \
594 *-*-mpw*)
595 # Macs want a resource compiler.
596 configdirs="$configdirs grez"
597 ;;
598 esac
599
600 # targets that need a second pass
601 case "${target}" in
602 *-gm-magic*)
603 noconfigdirs="$noconfigdirs target-libgloss"
604 ;;
605 esac
606
607 # If we aren't building newlib, then don't build libgloss, since libgloss
608 # depends upon some newlib header files.
609 case "${noconfigdirs}" in
610 *target-libgloss*) ;;
611 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
612 esac
613
614 # If we are building a Canadian Cross, discard tools that can not be built
615 # using a cross compiler. FIXME: These tools should be fixed.
616 if [ "${build}" != "${host}" ]; then
617 noconfigdirs="$noconfigdirs expect dejagnu itcl db sn"
618 fi
619
620 # Make sure we don't let GNU ld be added if we didn't want it.
621 if [ x$with_gnu_ld = xno ]; then
622 use_gnu_ld=no
623 noconfigdirs="$noconfigdirs ld"
624 fi
625
626 # Make sure we don't let GNU as be added if we didn't want it.
627 if [ x$with_gnu_as = xno ]; then
628 use_gnu_as=no
629 noconfigdirs="$noconfigdirs gas"
630 fi
631
632 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
633 # $target_configdirs.
634 # If we have the source for $noconfigdirs entries, add them to $notsupp.
635
636 notsupp=""
637 for dir in . $skipdirs $noconfigdirs ; do
638 dirname=`echo $dir | sed -e s/target-//g`
639 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
640 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
641 if [ -r $srcdir/$dirname/configure ] \
642 || [ -r $srcdir/$dirname/configure.in ]; then
643 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
644 true
645 else
646 notsupp="$notsupp $dir"
647 fi
648 fi
649 fi
650 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
651 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
652 if [ -r $srcdir/$dirname/configure ] \
653 || [ -r $srcdir/$dirname/configure.in ]; then
654 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
655 true
656 else
657 notsupp="$notsupp $dir"
658 fi
659 fi
660 fi
661 done
662
663 # Sometimes the tools are distributed with libiberty but with no other
664 # libraries. In that case, we don't want to build target-libiberty.
665 if [ -n "${target_configdirs}" ]; then
666 others=
667 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
668 if [ "$i" != "libiberty" ]; then
669 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
670 others=yes;
671 break;
672 fi
673 fi
674 done
675 if [ -z "${others}" ]; then
676 target_configdirs=
677 fi
678 fi
679
680 # Deconfigure all subdirectories, in case we are changing the
681 # configuration from one where a subdirectory is supported to one where it
682 # is not.
683 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
684 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
685 rm -f $i/Makefile
686 done
687 fi
688 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
689 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
690 rm -f ${target_subdir}/$i/Makefile
691 done
692 fi
693
694 # Produce a warning message for the subdirs we can't configure.
695 # This isn't especially interesting in the Cygnus tree, but in the individual
696 # FSF releases, it's important to let people know when their machine isn't
697 # supported by the one or two programs in a package.
698
699 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
700 # If $appdirs is non-empty, at least one of those directories must still
701 # be configured, or we error out. (E.g., if the gas release supports a
702 # specified target in some subdirs but not the gas subdir, we shouldn't
703 # pretend that all is well.)
704 if [ -n "$appdirs" ]; then
705 for dir in $appdirs ; do
706 if [ -r $dir/Makefile.in ]; then
707 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
708 appdirs=""
709 break
710 fi
711 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
712 appdirs=""
713 break
714 fi
715 fi
716 done
717 if [ -n "$appdirs" ]; then
718 echo "*** This configuration is not supported by this package." 1>&2
719 exit 1
720 fi
721 fi
722 # Okay, some application will build, or we don't care to check. Still
723 # notify of subdirs not getting built.
724 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
725 echo " ${notsupp}" 1>&2
726 echo " (Any other directories should still work fine.)" 1>&2
727 fi
728
729 # Set with_gnu_as and with_gnu_ld as appropriate.
730 #
731 # This is done by determining whether or not the appropriate directory
732 # is available, and by checking whether or not specific configurations
733 # have requested that this magic not happen.
734 #
735 # The command line options always override the explicit settings in
736 # configure.in, and the settings in configure.in override this magic.
737 #
738 # If the default for a toolchain is to use GNU as and ld, and you don't
739 # want to do that, then you should use the --without-gnu-as and
740 # --without-gnu-ld options for the configure script.
741
742 if [ x${use_gnu_as} = x ] ; then
743 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
744 with_gnu_as=yes
745 withoptions="$withoptions --with-gnu-as"
746 fi
747 fi
748
749 if [ x${use_gnu_ld} = x ] ; then
750 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
751 with_gnu_ld=yes
752 withoptions="$withoptions --with-gnu-ld"
753 fi
754 fi
755
756 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
757 # can detect this case.
758
759 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
760 with_newlib=yes
761 withoptions="$withoptions --with-newlib"
762 fi
763
764 if [ x${shared} = xyes ]; then
765 case "${target}" in
766 hppa*) target_makefile_frag=config/mt-papic ;;
767 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
768 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
769 esac
770 fi
771
772 # post-target:
773
774 # Make sure that the compiler is able to generate an executable. If it
775 # can't, we are probably in trouble. We don't care whether we can run the
776 # executable--we might be using a cross compiler--we only care whether it
777 # can be created. At this point the main configure script has set CC.
778 echo "int main () { return 0; }" > conftest.c
779 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
780 if [ $? = 0 ] && [ -s conftest ]; then
781 :
782 else
783 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
784 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
785 rm -f conftest*
786 exit 1
787 fi
788 rm -f conftest*
789
790 # The Solaris /usr/ucb/cc compiler does not appear to work.
791 case "${host}" in
792 sparc-sun-solaris2*)
793 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
794 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
795 could_use=
796 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
797 if [ -d /opt/cygnus/bin ] ; then
798 if [ "$could_use" = "" ] ; then
799 could_use="/opt/cygnus/bin"
800 else
801 could_use="$could_use or /opt/cygnus/bin"
802 fi
803 fi
804 if [ "$could_use" = "" ] ; then
805 echo "Warning: compilation may fail because you're using"
806 echo "/usr/ucb/cc. You should change your PATH or CC "
807 echo "variable and rerun configure."
808 else
809 echo "Warning: compilation may fail because you're using"
810 echo "/usr/ucb/cc, when you should use the C compiler from"
811 echo "$could_use. You should change your"
812 echo "PATH or CC variable and rerun configure."
813 fi
814 fi
815 ;;
816 esac
817
818 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
819 # binutils tools will find libbfd.so.
820 if [ "${shared}" = "yes" ]; then
821 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
822 Makefile > Makefile.tem
823 rm -f Makefile
824 mv -f Makefile.tem Makefile
825
826 case "${host}" in
827 *-*-hpux*)
828 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
829 Makefile > Makefile.tem
830 rm -f Makefile
831 mv -f Makefile.tem Makefile
832 ;;
833 esac
834 fi
835
836 # Record target_configdirs and the configure arguments in Makefile.
837 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
838 targargs=`echo "${arguments}" | \
839 sed -e 's/--norecursion//' \
840 -e 's/--cache[a-z-]*=[^ ]*//' \
841 -e 's/--ho[a-z-]*=[^ ]*//' \
842 -e 's/--ta[a-z-]*=[^ ]*//'`
843
844 # Passing a --with-cross-host argument lets the target libraries know
845 # whether they are being built with a cross-compiler or being built
846 # native. However, it would be better to use other mechanisms to make the
847 # sorts of decisions they want to make on this basis. Please consider
848 # this option to be deprecated. FIXME.
849 if [ x${is_cross_compiler} = xyes ]; then
850 targargs="--with-cross-host=${host_alias} ${targargs}"
851 fi
852
853 targargs="--host=${target_alias} ${targargs}"
854 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
855 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
856 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
857 Makefile > Makefile.tem
858 rm -f Makefile
859 mv -f Makefile.tem Makefile
860
861 #
862 # Local Variables:
863 # fill-column: 131
864 # End:
865 #
This page took 0.056368 seconds and 4 git commands to generate.